#pragma once

template <typename T>
class AutoPtr
{
public:
	inline AutoPtr() {};
	inline AutoPtr(T* px) : pd(px) {};
	AutoPtr(AutoPtr& other) = delete;
	AutoPtr& operator=(AutoPtr other) = delete;
	AutoPtr& operator=(AutoPtr& other) = delete;
	AutoPtr& operator=(const AutoPtr& other) = delete;
	inline void set(T* other) {
		if (pd != nullptr) {
			delete pd;
		}
		pd = other;
	}
	inline T* ptr() {
		return pd;
	}
	inline T& data() {
		return *pd;
	}
	inline T* take() {
		auto pd1 = pd;
		pd = nullptr;
		return pd1;
	}
	~AutoPtr() {
		if (pd != nullptr) {
			delete pd;
		}
	}
private:
	T* pd = nullptr;
};