#include "ErrorBuffer.h"

#include "unicode.h"

#include <iostream>

inline std::u8string to_u8string(int n) {
	const std::string& s = std::to_string(n);
	return std::u8string(s.begin(), s.end());
}

ErrorBuffer::ErrorBuffer() {

}

ErrorBuffer::~ErrorBuffer() {
	int i = 0;
	int j = 0;
	i = 1;
}

void ErrorBuffer::push(const std::u8string& file_path, int line_pos, int column_pos, const std::u8string& diagnosis_string)
{
	DiagnosisLine cl;
	cl.file_path = file_path;
	cl.line_pos = line_pos;
	cl.column_pos = column_pos;
	cl.diagnosis_string = file_path + u8" (" + to_u8string(line_pos) + u8", " + to_u8string(column_pos) + u8") : " + diagnosis_string;
	this->buffer.push_back(cl);
}

void ErrorBuffer::push(const std::u8string& file_path, const std::u8string& diagnosis_string) {
	DiagnosisLine cl;
	cl.file_path = file_path;
	cl.line_pos = -1;
	cl.column_pos = -1;
	cl.diagnosis_string = file_path + u8": " + diagnosis_string;
	this->buffer.push_back(cl);
}

int ErrorBuffer::count() {
	return buffer.size();
}

void ErrorBuffer::flush() {
	if (count()) {
		for (int i = 0; i < buffer.size(); ++i)
		{
			std::cout << To_CppString(buffer[i].diagnosis_string) << std::endl;
		}
		buffer.clear();
	}
}