#pragma once

#include <string>
#include <vector>

class DiagnosisLine
{
public:
	int line_pos;
	int column_pos;
	std::u8string file_path;
	std::u8string diagnosis_string;
};

class ErrorBuffer
{
public:
	ErrorBuffer();
	~ErrorBuffer();
	ErrorBuffer(const ErrorBuffer& other) = delete;
	ErrorBuffer& operator=(const ErrorBuffer& other) = delete;
	void push(const std::u8string& file_path, int line_pos, int column_pos, const std::u8string& diagnosis_string);
	void push(const std::u8string& file_path, const std::u8string& diagnosis_string);
	int count();
	void flush();
private:
	std::vector<DiagnosisLine> buffer;
};

extern ErrorBuffer SErrorBuffer;
