#include "ModuleCache.h"

#include "Components/ModuleComponent/ModuleComponent.h"

ModuleComponent* ModuleCache::queryModuleCache(const std::u8string& path) {
	auto pd = cache.find(path);
	if (pd != cache.end()) {
		return pd->second;
	}
	return nullptr;
}

bool ModuleCache::updateModuleCache(const std::u8string& path, ModuleComponent* mod) {
	if (mod == nullptr) {
		return false;
	}
	if (queryModuleCache(path)) {
		return false;
	}
	cache[path] = mod;
	return true;
}
