#pragma once

#include "ModuleEc.h"

#include "Components/ModuleComponent/FunctionDefinitionComponent.h"

#include <vector>
#include <string>

class SpecifiedClassNotion;
class FunctionDefinitionComponent;
class ExprComponent;

class AttributeDefine
{
public:
	inline ~AttributeDefine() {
		if (cls != nullptr) { delete cls; }
		if (func != nullptr) { delete func; }
	}
	std::u32string name;
	ExprComponent* cls = nullptr;
	bool is_export = false;
	bool is_static = false;
	bool is_function = false;
	FunctionDefinitionComponent* func = nullptr;
};

class ClassDefinitionComponent : public ModuleStatementBase
{
public:
	inline ClassDefinitionComponent() : ModuleStatementBase(ModuleEcKind::class_define) {};
	inline ~ClassDefinitionComponent() {
		if (ep != nullptr) {
			delete ep;
		}
		if (attrs && attrs->size()) {
			for (auto s : *attrs) {
				delete s;
			}
			delete attrs;
		}
		if (ep) {
			for (auto s : *ep) {
				delete s;
			}
		}
	}
	std::u32string name;
	bool is_export = false;
	bool is_second = false;
	bool is_template = false;
	bool is_completed = false;
	ExprComponent* tp = nullptr;
	std::vector<ExprComponent*>* ep = nullptr;
	std::vector<AttributeDefine*>* attrs = nullptr;
	Token token;
};