#pragma once

#include <string>
#include <vector>

#include "Components/Parser/Token.h"
#include "Components/ModuleComponent/SpecifiedClassNotion.h"

class SpecifiedClassNotion;

enum class ExprComponentKind
{
	quantity,
	identifier,
	unary,
	binary,
	bracket,
	chunk,
	reverse
};

class ExprComponent
{
public:
	inline ExprComponent(ExprComponentKind kind_, const Token& token_) : kind(kind_), token(token_) {};
	inline ~ExprComponent() {
		if (S[0] != nullptr) { delete S[0]; };
		if (S[1] != nullptr) { delete S[1]; };
		if (sp && sp->size()) {
			for (auto s : *sp) {
				delete s;
			}
		}
	}
	ExprComponentKind kind;
	std::u32string quantity;
	std::u32string op;
	std::u32string identifier;
	ExprComponent* S[2] = { nullptr, nullptr };
	std::vector<ExprComponent*>* sp = nullptr;
public:
	Token token;
};