#pragma once

#include <vector>
#include <string>

#include "Components/ModuleComponent/StatementComponent.h"

class SpecifiedClassNotion;
class StatementComponent;
class ExprComponent;

class FunctionDefinitionML
{
public:
	inline ~FunctionDefinitionML() {
		if (rt != nullptr) { delete rt; }
		if (S != nullptr) { delete S; }
		if (sp != nullptr) { delete sp; }
	};
public:
	ExprComponent* rt = nullptr;
	std::u32string name;
	bool is_export = false;
	bool is_edge = false;
	bool is_static = false;
	bool mutable_mark = false;
	bool perform_mark = false;
	ExprComponent* sp = nullptr;
	StatementComponent* S = nullptr;
};

class FunctionDefinitionComponent
{
public:
	~FunctionDefinitionComponent() {
		if (ml != nullptr) { 
			delete ml;
		}
	}
public:
	FunctionDefinitionML* ml = nullptr;
};
