#pragma once

#include <optional>
#include <set>

#include "ModuleEc.h"
#include "SpecifiedClassNotion.h"

class ModuleComponent;
class SpecifiedClassNotion;
class ClassDefinitionComponent;

class PackageStatmentEc : public ModuleStatementBase
{
public:
	std::vector<std::u32string> pt;
};

class ImportStatmentEc : public ModuleStatementBase
{
public:
	std::vector<std::u32string> packageName;
	ModuleComponent* mod = nullptr;
};

class ModuleComponent
{
public:
	ModuleComponent() {}
	~ModuleComponent() {
		if (S.size()) {
			for (auto s : S) {
				delete s;
			}
		}
		if (class_notion.size()) {
			for (auto s : class_notion) {
				delete s;
			}
		}
	};
	std::u8string file_path;
	std::vector<std::u32string> package_name;
	std::set<std::u8string> import_module;
	std::vector<ModuleStatementBase*> S;
	std::vector<SpecifiedClassNotion*> class_notion;
	std::vector<ClassDefinitionComponent*> class_def;
	bool validated = false;
};