#pragma once

#include <vector>

#include "Components/Parser/Token.h"
#include "Components/ModuleComponent/ExprComponent.h"

class ExprComponent;

enum class StatementComponentKind
{
	empty_statement,
	expr_statement,
	if_statement,
	for_statement,
	for_iter_statement,
	while_statement,
	break_statement,
	continue_statement,
	return_statement,
	block_statement,
	reverse
};

class StatementComponent
{
public:
	inline StatementComponent(StatementComponentKind kind_) : kind(kind_) {};
	inline ~StatementComponent() {
		for (int i = 0; i < 3; ++i) {
			if (SC[i] != nullptr) {
				delete SC[i];
			}
		}
		for (int i = 0; i < 2; ++i) {
			if (S[i] != nullptr) {
				delete S[i];
			}
		}
		if(sp && sp->size()){
			for (auto s : *sp) {
				delete s;
			}
		}
	}
	StatementComponentKind kind;
	ExprComponent* SC[3] = { nullptr, nullptr, nullptr };
	std::vector<StatementComponent*>* sp = nullptr;
	StatementComponent* S[2] = { nullptr, nullptr };
	Token token;
};