#pragma once

#include <string>

class Scanner
{
public:
	void initScanner(const std::u8string& file_path, const std::u32string& chunk);
	const std::u32string& getChunkData();
	bool testSequence(const std::u32string& s);
	void dropOrEnd();
	char32_t copyOrEnd();
	char32_t dropAndCopy();
	void skipBlank();
	int skipLineOrEnd();
	int skipUntilStringOrEnd(const std::u32string& s);
	int skipCountOrEnd(int n);
	std::u32string copyUntilStringAndDrop(const std::u32string& s);
	const std::u8string& getFileName();
	int getLine();
	int getColumn();
	int getIndent();
	bool isEnd();
	void setEnd();
private:
	std::u8string file_name;
	std::u32string chunk;
	int next;
	int end;
	int line_pos;
	int column_pos;
	int indent;
	bool indentEnd;
};