#pragma once

#include <string>

#include "TokenKind.h"

class Token
{
public:
	Token();
	Token(TokenKind kind, std::u32string value, int line_pos, int column_pos);
	bool testRandom(const std::u32string& s);
	bool isIdentifier();
	bool isOpenBracket();
	bool isCloseBracket();
	bool isBracket(const std::u32string& s);
	bool isKeyword(const std::u32string& s);
	std::string makePrintable();
public:
	TokenKind kind;
	std::u32string value;
	int line_pos;
	int column_pos;
};

inline int pairBracket(int c) {
	if (c == '(') return ')';
	if (c == ')') return '(';
	if (c == '[') return ']';
	if (c == ']') return '[';
	if (c == '{') return '}';
	if (c == '}') return '{';
	return c;
}