#pragma once

#include <string>

class ModuleCache;
class ModuleValidation;
class ModuleComponent;

class LogicLanguageProcessRuntime {
public:
	LogicLanguageProcessRuntime();
	~LogicLanguageProcessRuntime();
public:
	ModuleValidation* valid = nullptr;
	ModuleCache* mcache = nullptr;
};

class LogicLanguageProcess {
public:
	static LogicLanguageProcessRuntime* Runtime();
	void printExprOnce(const std::u8string& file_path);
	void printStatementOnce(const std::u8string& file_path);
	void printFunctionDefineOnce(const std::u8string& file_path);
	void printClassDefineOnce(const std::u8string& file_path);
	bool ImportModule(ModuleComponent* outerModule, const std::u8string& file_path);
	ModuleComponent* CompileModule(const std::u8string& file_path);
	int Build(int argc, char** argv);
private:
	static LogicLanguageProcessRuntime* Runtime_;
};