#include "compiler.h"

#include "Components/DefaultConfig/DefaultConfig.h"
#include "Components/ErrorBuffer/ErrorBuffer.h"

#include "Modules/LLP.h"
#include "Modules/ELP.h"

DefaultConfig SDefaultConfig;

LexicalRule SLexicalRule;

ErrorBuffer SErrorBuffer;

static LogicLanguageProcess* LLP;
static EntityLanguageProcess* ELP;

LogicLanguageProcess* queryLLP() {
	return LLP;
}

EntityLanguageProcess* queryELP() {
	return ELP;
}


int main(int argc, char** argv) {
	LLP = new LogicLanguageProcess;
	ELP = new EntityLanguageProcess;
	return LLP->Build(argc, argv);
}